#! /usr/bin/python2

import sys
from omniORB import CORBA, PortableServer

from RealTimeTaskDelegateImpl import *

class ATRAdvocate(RealTimeTaskDelegateImpl):
    def __init__(self):
        RealTimeTaskDelegateImpl.__init__(self)
        self.detect_window = [0] * 20
        self.detect_index = 0
        self.range_high = 0
        self.range_mid = 0
        self.over_thresh = 0.50
        self.max_gap_size = 0
        self.max_run_size = 0
        self.last_advice = 0
        self.confidence = 0
        return

    def get_detect_index(self, index):
        return index % len(self.detect_window)

    def update(self, status):
        self.detect_window[self.get_detect_index(self.detect_index)] = status
        self.detect_index = self.detect_index + 1
        return

    def detect(self):
        self.range_high = max(self.detect_window)
        self.range_mid = None
        for x in self.detect_window:
            if float(x) / self.range_high < self.over_thresh:
                if self.range_mid:
                    self.range_mid = max((self.range_mid, x))
                    pass
                else:
                    self.range_mid = x
                    pass
                pass
            pass
        self.range_high = self.range_high + long(self.range_high * 0.03)
        self.range_mid = self.range_mid + long(self.range_mid * 0.03)
        # print `self.detect_window`
        # print "range = " + `self.range_high` + " - " + `self.range_mid`
        runs = []
        run_size = 0
        for lpc in range(self.detect_index,
                         self.detect_index + len(self.detect_window)):
            x = self.detect_window[self.get_detect_index(lpc)]
            if x <= self.range_mid:
                runs.append(run_size)
                run_size = 0
                pass
            else:
                run_size = run_size + 1
                pass
            pass
        gaps = []
        gap_size = 0
        for lpc in range(self.detect_index,
                         self.detect_index + len(self.detect_window)):
            x = self.detect_window[self.get_detect_index(lpc)]
            if x > self.range_mid:
                gaps.append(gap_size)
                gap_size = 0
                pass
            else:
                gap_size = gap_size + 1
                pass
            pass
        if len(runs) > 0:
            self.max_run_size = max(runs)
            pass
        else:
            self.max_run_size = 0
            pass
        if len(gaps) > 0:
            self.max_gap_size = gaps[len(gaps) - 1] # max(gaps)
            pass
        else:
            self.max_gap_size = 0
            pass
        
        # print "mrs = " + `self.max_run_size`
        # print "mgs = " + `self.max_gap_size`
        return

    def predict(self, status):
        if self.detect_window[
            self.get_detect_index(self.detect_index - 1)] > self.range_mid:
            # run
            lpc = 0
            while self.detect_window[self.get_detect_index(
                self.detect_index - lpc - 1)] > self.range_mid:
                lpc = lpc + 1
                pass
            # print "run " + `lpc`
            if lpc < self.max_run_size:
                retval = self.range_high
                pass
            else:
                retval = self.range_mid
                pass
            pass
        else:
            # gap
            lpc = 0
            while self.detect_window[self.get_detect_index(
                self.detect_index - lpc - 1)] <= self.range_mid:
                lpc = lpc + 1
                pass
            # print "gap " + `lpc`
            if lpc < self.max_gap_size:
                retval = self.range_mid
                pass
            else:
                retval = self.range_high
                pass
            pass
        return retval
    
    def ReportCPU(self, rtt, status, advice):
        # print "predict " + `self.last_advice` + " - " + `status`,
        if status > self.range_mid:
            if self.last_advice == self.range_high:
                self.confidence = self.confidence + 1
                # print "  Hit **"
                pass
            else:
                self.confidence = 0
                # print "  Miss :("
                pass
            pass
        else:
            if self.last_advice == self.range_mid:
                self.confidence = self.confidence + 1
                # print "  Hit **"
                pass
            else:
                self.confidence = 0
                # print "  Miss :("
                pass
            pass
        self.update(status)
        self.detect()
        advice = self.predict(status)
        self.last_advice = advice
        #if self.confidence < (self.max_gap_size + self.max_run_size):
            # print "No confidence"
        #    advice = self.range_high
        #    pass
        # Call the wrapped object
        self.myRemoteObject.ReportCPU(rtt,
                                      status,
                                      advice)
        return
    pass

## aa = ATRAdvocate()

## aa.detect_window = [10, 10, 5, 5, 10, 10, 5, 5]

## for x in range(10, 15):
##     aa.detect_index = x
##     aa.detect()
##     print aa.predict(aa.detect_window[aa.get_detect_index(x)])
##     pass

orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)
poa = orb.resolve_initial_references("RootPOA")

di = ATRAdvocate()
do = di._this()

file = open(sys.argv[1], "w")
file.write(orb.object_to_string(do))
file.close()

poaManager = poa._get_the_POAManager()
poaManager.activate()

orb.run()
