/*
 * factory_library.c
 *
 * Copyright (c) 2003 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * This file is licensed under the terms of the GNU Public License.  
 * See the file "license.terms" for restrictions on redistribution 
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

/**
 * @file factory_library.c
 *
 * Implementation of the functions in factory_library.h.
 */

#include "config.h"

#include <assert_pp.h>

#include "factory_library.h"

int flFactoryMethod(factory_method_t fm,
		    factory_library_op_t op,
		    int tag,
		    ...)
{
    int retval;
    va_list args;

    require(fm != NULL);
    require(op > FLO_MIN);
    require(op < FLO_MAX);

    va_start(args, tag);
    retval = fm(op, tag, args);
    va_end(args);
    return( retval );
}
