#! /bin/sh

QUO_KERNEL=${top_builddir}/qosket/basic/cpp/basic_kernel
CBHEY=${top_builddir}/cbhey/src/cbhey

$QUO_KERNEL &
KERNEL_PID="$!"

trap 'kill $KERNEL_PID' EXIT

sleep 2

##

run_test $CBHEY -l

grep_output_for "IDL:quo/QuoKernel:1.0" \
    "Unable to list supported interfaces?"

##

run_test $CBHEY -l

grep_output_for "IDL:quo/ValueSC:1.0" \
    "Unable to list supported interfaces (2)?"

##

$CBHEY file://quoKernel.ior create sys-cond with app-id test idl-type quo::ValueSC impl-type quo_sc::ValueSCImpl > sc.ior

##

run_test $CBHEY file://sc.ior list

check_output "Unable to list root properties?" <<EOF
long-value
EOF

##

run_test $CBHEY file://sc.ior set long-value to 2

check_output "Unable to set long-value?" <<EOF
ok
EOF

##

run_test $CBHEY file://sc.ior get long-value

check_output "Unable to get long-value?" <<EOF
2
EOF

##

run_test $CBHEY file://sc.ior set long-value to 5

check_output "Unable to set long-value (2)?" <<EOF
ok
EOF

##

run_test $CBHEY file://sc.ior get long-value

check_output "Unable to get long-value (2)?" <<EOF
5
EOF

##
